Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 155926 - [RHEL4-U2][Diskdump] OS_INIT dump function is broken
Summary: [RHEL4-U2][Diskdump] OS_INIT dump function is broken
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel
Version: 4.0
Hardware: ia64
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Nobuhiro Tachino
QA Contact: Brian Brock
URL:
Whiteboard:
Depends On:
Blocks: 181409
TreeView+ depends on / blocked
 
Reported: 2005-04-25 20:03 UTC by Yuuichi Nagahama
Modified: 2018-10-19 19:03 UTC (History)
8 users (show)

Fixed In Version: RHSA-2006-0575
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2006-08-10 21:03:47 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2006:0575 normal SHIPPED_LIVE Important: Updated kernel packages available for Red Hat Enterprise Linux 4 Update 4 2006-08-10 04:00:00 UTC

Description Yuuichi Nagahama 2005-04-25 20:03:25 UTC
Description of Problem:
When crashdump is executed via OS_INIT on IPF machine, backtrace
command, which is a subcommand of crash, does not work correctly.

Two problems were found in the OS_INIT code.

(1) OS_INIT handler has two stages.
    stage1: handler written by assembler
    stage2: handler written by C
  The former is ia64_monarch_init_handler and ia64_slave_init_handler.
  The latter is ia64_init_handler. ia64_init_handler is called only by
  ia64_monarch_init_handler.
  When INIT interrupt is asserted, one cpu calls
  ia64_monarch_init_handler and the others call
  ia64_slave_init_handler. It means that ia64_init_handler is called
  by only one cpu. In that case, backtrace command fails. To make
  backtrace succeed, all cpus need to call ia64_monarch_init_handler.

(2) The second problem occurs by correcting the first problem.
  When OS_INIT handler is called, SAL hands the handler some
  information through registers. The handler preserves this information
  in ia64_sal_to_os_handoff_state. (Please see
  SAL_TO_OS_MCA_HANDOFF_STATE_SAVE macro in the
  arch/ia64/kernel/mca_asm.S.) If all cpus call
  ia64_monarch_init_handler at the same time, they write their own
  information to the ia64_sal_to_os_handoff_state simultaneously and
  break their contents.

Version-Release number:
kernel-2.6.9-6.37.EL

How reproducible:
always

Steps to Reproduce:
1. Enable Diskdump
2. Push OS_INIT switch
3. bt with crash command

Actual results:
Backtrace command does not work

Expected results:
Backtrace command works correctly

Additional info:
none

Comment 4 Nobuhiro Tachino 2005-05-17 18:22:15 UTC
The patch was posted to rhkernel-list ML

Comment 5 Nobuhiro Tachino 2005-06-20 21:14:41 UTC
I posted the updated patch to rhkernel-list ML on 6/16. The patch was updated to
reflect the comments which are made on the patch for RHEL3.


Comment 6 Nobuhiro Tachino 2005-06-27 21:40:11 UTC
I posted correct patch again to rhkernel-list ML

Comment 7 Linda Wang 2005-08-09 15:55:23 UTC
Hi Tachino-San, due to concern over wether or not this patch has been accepted
upstream, we are unable to take this patch in U2.  Once we know the status of
the  patch with upstream kernel, we will then be able to put it in U3. Many thanks. 

Comment 9 Nobuhiro Tachino 2005-10-24 18:12:18 UTC
The upstream solves this problem in a different way, This part of upstream
source already becomes very different from the one of RHEL4 and simple backport
will produce the big patch. I need more time to investigate the upstream source
to decide which patch is better to be included in RHEL4.


Comment 10 Nobuhiro Tachino 2005-11-11 15:47:14 UTC
The patch was posted to rhkernel-list. It is the same as the previous patch. I
tried to port the upstream fix to RHEL4, but it makes big patch over 1kstep. So
I think the original patch is better to be included in RHEL4.


Comment 14 Jason Baron 2006-04-27 15:01:11 UTC
committed in stream U4 build 34.25. A test kernel with this patch is available
from http://people.redhat.com/~jbaron/rhel4/


Comment 19 Red Hat Bugzilla 2006-08-10 21:03:47 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0575.html



Note You need to log in before you can comment on or make changes to this bug.